IRremoteESP8266

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | List of all members
IRTrotec3550 Class Reference

Class for handling detailed Trotec 3550 A/C messages. More...

`#include <ir_Trotec.h>`

Collaboration diagram for IRTrotec3550:
[legend]

## Public Member Functions
| IRTrotec3550 (const uint16_t pin, const bool inverted=false, const bool use_modulation=true)
| Class constructor. More...
void | send (const uint16_t repeat=kTrotecDefaultRepeat)
| Send the current internal state as an IR message. More...
int8_t | calibrate (void)
| Run the calibration to calculate uSec timing offsets for this platform. More...
void | begin (void)
| Set up hardware to be able to send a message. More...
void | stateReset (void)
| Reset the state of the remote to a known good state/sequence. More...
void | on (void)
| Set the requested power state of the A/C to on. More...
void | off (void)
| Set the requested power state of the A/C to off. More...
void | setPower (const bool state)
| Change the power setting. More...
bool | getPower (void) const
| Get the value of the current power setting. More...
void | setTemp (const uint8_t degrees, const bool celsius=true)
| Set the temperature. More...
uint8_t | getTemp (void) const
| Get the current temperature setting. More...
void | setTempUnit (const bool celsius)
| Set the temperature unit that the A/C will use.. More...
bool | getTempUnit (void) const
| Get the current temperature unit setting. More...
void | setFan (const uint8_t fan)
| Set the speed of the fan. More...
uint8_t | getFan (void) const
| Get the current fan speed setting. More...
uint8_t | getMode (void) const
| Get the operating mode setting of the A/C. More...
void | setMode (const uint8_t mode)
| Set the operating mode of the A/C. More...
bool | getSwingV (void) const
| Get the value of the current Vertical Swing setting. More...
void | setSwingV (const bool on)
| Change the Vertical Swing setting. More...
uint16_t | getTimer (void) const
| Get the number of minutes of the Timer setting. More...
void | setTimer (const uint16_t mins)
| Set the number of minutes of the Timer setting. More...
uint8_t * | getRaw (void)
| Get a PTR to the internal state/code for this protocol. More...
void | setRaw (const uint8_t state[])
| Set the internal state from a valid code for this protocol. More...
stdAc::state_t | toCommon (void) const
| Convert the current internal state into its stdAc::state_t equivalent. More...
String | toString (void) const
| Convert the current internal state into a human readable string. More...

## Static Public Member Functions
static bool | validChecksum (const uint8_t state[], const uint16_t length=kTrotecStateLength)
| Verify the checksum is valid for a given state. More...
static uint8_t | calcChecksum (const uint8_t state[], const uint16_t length=kTrotecStateLength)
| Calculate the checksum for a given state. More...
static uint8_t | convertMode (const stdAc::opmode_t mode)
| Convert a stdAc::opmode_t enum into its native mode. More...
static uint8_t | convertFan (const stdAc::fanspeed_t speed)
| Convert a stdAc::fanspeed_t enum into it's native speed. More...
static stdAc::opmode_t | toCommonMode (const uint8_t mode)
| Convert a native mode into its stdAc equivalent. More...
static stdAc::fanspeed_t | toCommonFanSpeed (const uint8_t speed)
| Convert a native fan speed into its stdAc equivalent. More...

## Private Member Functions
void | checksum (void)
| Calculate & set the checksum for the current internal state of the remote. More...

## Private Attributes
IRsend | _irsend
| Instance of the IR send class. More...
Trotec3550Protocol | _

## Detailed Description

Class for handling detailed Trotec 3550 A/C messages.

## Constructor & Destructor Documentation

## ◆ IRTrotec3550()

IRTrotec3550::IRTrotec3550 | ( | const uint16_t | pin,
|  | const bool | inverted = `false`,
|  | const bool | use_modulation = `true`
| ) |  |
| explicit

Class constructor.

Parameters

  [in] | pin | GPIO to be used when sending.
  [in] | inverted | Is the output signal to be inverted?
  [in] | use_modulation | Is frequency modulation to be used?

## Member Function Documentation

## ◆ begin()

void IRTrotec3550::begin | ( | void |  | ) |

Set up hardware to be able to send a message.

## ◆ calcChecksum()

uint8_t IRTrotec3550::calcChecksum | ( | const uint8_t | state[],
|  | const uint16_t | length = `kTrotecStateLength`
| ) |  |
| static

Calculate the checksum for a given state.

Parameters

  [in] | state | The array to calc the checksum of.
  [in] | length | The length/size of the array.

Returns
  The calculated checksum value.

## ◆ calibrate()

int8_t IRTrotec3550::calibrate | ( | void |  | ) |
| inline

Run the calibration to calculate uSec timing offsets for this platform.

Returns
  The uSec timing offset needed per modulation of the IR Led.

Note
  This will produce a 65ms IR signal pulse at 38kHz. Only ever needs to be run once per object instantiation, if at all.

## ◆ checksum()

void IRTrotec3550::checksum | ( | void |  | ) |
| private

Calculate & set the checksum for the current internal state of the remote.

## ◆ convertFan()

uint8_t IRTrotec3550::convertFan | ( | const stdAc::fanspeed_t | speed | ) |
| static

Convert a stdAc::fanspeed_t enum into it's native speed.

Parameters

  [in] | speed | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ convertMode()

uint8_t IRTrotec3550::convertMode | ( | const stdAc::opmode_t | mode | ) |
| static

Convert a stdAc::opmode_t enum into its native mode.

Parameters

  [in] | mode | The enum to be converted.

Returns
  The native equivalent of the enum.

## ◆ getFan()

uint8_t IRTrotec3550::getFan | ( | void |  | ) | const

Get the current fan speed setting.

Returns
  The current fan speed/mode.

## ◆ getMode()

uint8_t IRTrotec3550::getMode | ( | void |  | ) | const

Get the operating mode setting of the A/C.

Returns
  The current operating mode setting.

## ◆ getPower()

bool IRTrotec3550::getPower | ( | void |  | ) | const

Get the value of the current power setting.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getRaw()

uint8_t * IRTrotec3550::getRaw | ( | void |  | ) |

Get a PTR to the internal state/code for this protocol.

Returns
  PTR to a code for this protocol based on the current internal state.

## ◆ getSwingV()

bool IRTrotec3550::getSwingV | ( | void |  | ) | const

Get the value of the current Vertical Swing setting.

Returns
  true, the setting is on. false, the setting is off.

## ◆ getTemp()

uint8_t IRTrotec3550::getTemp | ( | void |  | ) | const

Get the current temperature setting.

Returns
  The current setting for temp. in degrees.

## ◆ getTempUnit()

bool IRTrotec3550::getTempUnit | ( | void |  | ) | const

Get the current temperature unit setting.

Returns
  True, Celsius; False Fahrenheit.

## ◆ getTimer()

uint16_t IRTrotec3550::getTimer | ( | void |  | ) | const

Get the number of minutes of the Timer setting.

Returns
  Nr of minutes.

## ◆ off()

void IRTrotec3550::off | ( | void |  | ) |

Set the requested power state of the A/C to off.

## ◆ on()

void IRTrotec3550::on | ( | void |  | ) |

Set the requested power state of the A/C to on.

## ◆ send()

void IRTrotec3550::send | ( | const uint16_t | repeat = `kTrotecDefaultRepeat` | ) |

Send the current internal state as an IR message.

Parameters

  [in] | repeat | Nr. of times the message will be repeated.

## ◆ setFan()

void IRTrotec3550::setFan | ( | const uint8_t | fan | ) |

Set the speed of the fan.

Parameters

  [in] | fan | The desired setting.

## ◆ setMode()

void IRTrotec3550::setMode | ( | const uint8_t | mode | ) |

Set the operating mode of the A/C.

Parameters

  [in] | mode | The desired operating mode.

## ◆ setPower()

void IRTrotec3550::setPower | ( | const bool | on | ) |

Change the power setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setRaw()

void IRTrotec3550::setRaw | ( | const uint8_t | state[] | ) |

Set the internal state from a valid code for this protocol.

Parameters

  [in] | state | A valid code for this protocol.

## ◆ setSwingV()

void IRTrotec3550::setSwingV | ( | const bool | on | ) |

Change the Vertical Swing setting.

Parameters

  [in] | on | true, the setting is on. false, the setting is off.

## ◆ setTemp()

void IRTrotec3550::setTemp | ( | const uint8_t | degrees,
|  | const bool | celsius = `true`
| ) |  |

Set the temperature.

Parameters

  [in] | degrees | The temperature in degrees.
  [in] | celsius | Use celsius units. True, Celsius; False Fahrenheit.

## ◆ setTempUnit()

void IRTrotec3550::setTempUnit | ( | const bool | celsius | ) |

Set the temperature unit that the A/C will use..

Parameters

  [in] | celsius | Use celsius units. True, Celsius; False Fahrenheit.

## ◆ setTimer()

void IRTrotec3550::setTimer | ( | const uint16_t | mins | ) |

Set the number of minutes of the Timer setting.

Parameters

  [in] | mins | Nr. of Minutes for the Timer. `0` means disable the timer.

## ◆ stateReset()

void IRTrotec3550::stateReset | ( | void |  | ) |

Reset the state of the remote to a known good state/sequence.

## ◆ toCommon()

stdAc::state_t IRTrotec3550::toCommon | ( | void |  | ) | const

Convert the current internal state into its stdAc::state_t equivalent.

Returns
  The stdAc equivalent of the native settings.

## ◆ toCommonFanSpeed()

stdAc::fanspeed_t IRTrotec3550::toCommonFanSpeed | ( | const uint8_t | spd | ) |
| static

Convert a native fan speed into its stdAc equivalent.

Parameters

  [in] | spd | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toCommonMode()

stdAc::opmode_t IRTrotec3550::toCommonMode | ( | const uint8_t | mode | ) |
| static

Convert a native mode into its stdAc equivalent.

Parameters

  [in] | mode | The native setting to be converted.

Returns
  The stdAc equivalent of the native setting.

## ◆ toString()

String IRTrotec3550::toString | ( | void |  | ) | const

Convert the current internal state into a human readable string.

Returns
  A human readable string.

## ◆ validChecksum()

bool IRTrotec3550::validChecksum | ( | const uint8_t | state[],
|  | const uint16_t | length = `kTrotecStateLength`
| ) |  |
| static

Verify the checksum is valid for a given state.

Parameters

  [in] | state | The array to verify the checksum of.
  [in] | length | The length/size of the array.

Returns
  true, if the state has a valid checksum. Otherwise, false.

## Member Data Documentation

## ◆ _

Trotec3550Protocol IRTrotec3550::_
| private

## ◆ _irsend

IRsend IRTrotec3550::_irsend
| private

Instance of the IR send class.

The documentation for this class was generated from the following files:

- src/ir_Trotec.h
- src/ir_Trotec.cpp